Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/NST_SRC/agrif_user.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/NST_SRC/agrif_user.F90	(revision 2081)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/NST_SRC/agrif_user.F90	(revision 2082)
@@ -307,6 +307,6 @@
 #if defined key_top
         ! Check passive tracer cell
-        IF( ndttrc .ne. 1 ) THEN
-           WRITE(*,*) 'ndttrc should be equal to 1'
+        IF( nn_dttrc .ne. 1 ) THEN
+           WRITE(*,*) 'nn_dttrc should be equal to 1'
         ENDIF
 #endif
@@ -444,6 +444,6 @@
          ENDIF
         ! Check passive tracer cell
-        IF( ndttrc .ne. 1 ) THEN
-           WRITE(*,*) 'ndttrc should be equal to 1'
+        IF( nn_dttrc .ne. 1 ) THEN
+           WRITE(*,*) 'nn_dttrc should be equal to 1'
         ENDIF
 
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/OFF_SRC/dtadyn.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/OFF_SRC/dtadyn.F90	(revision 2081)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/OFF_SRC/dtadyn.F90	(revision 2082)
@@ -184,16 +184,14 @@
          
          IF( lk_ldfslp ) THEN
-            ! Computes slopes
-            ! Caution : here tn, sn and avt are used as workspace
-            tn (:,:,:) = tdta  (:,:,:,2)
-            sn (:,:,:) = sdta  (:,:,:,2)
-            avt(:,:,:) = avtdta(:,:,:,2)
-         
-            CALL eos( tn, sn, rhd, rhop )   ! Time-filtered in situ density 
-            CALL bn2( tn, sn, rn2 )         ! before Brunt-Vaisala frequency
+            ! Computes slopes. Caution : here tsn and avt are used as workspace
+            tsn (:,:,:,jp_tem) = tdta  (:,:,:,2)
+            tsn (:,:,:,jp_sal) = sdta  (:,:,:,2)
+            avt(:,:,:)         = avtdta(:,:,:,2)
+         
+            CALL eos( tsn, rhd, rhop )   ! Time-filtered in situ density 
+            CALL bn2( tsn, rn2 )         ! before Brunt-Vaisala frequency
             IF( ln_zps )   &
-               &   CALL zps_hde( kt, tn , sn , rhd,  &  ! Partial steps: before Horizontal DErivative
-               &                 gtu, gsu, gru,  &  ! of t, s, rd at the bottom ocean level
-               &                 gtv, gsv, grv )
+               &   CALL zps_hde( kt, jpts, tsn, gtsu, gtsv,  &  ! Partial steps: before Horizontal DErivative
+               &                           rhd, gru , grv   )    ! of t, s, rd at the bottom ocean level
                    CALL zdf_mxl( kt )              ! mixed layer depth
                    CALL ldf_slp( kt, rhd, rn2 )
@@ -213,16 +211,14 @@
          
          IF( lk_ldfslp ) THEN
-            ! Computes slopes
-            ! Caution : here tn, sn and avt are used as workspace
-            tn (:,:,:) = tdta  (:,:,:,2)
-            sn (:,:,:) = sdta  (:,:,:,2)
-            avt(:,:,:) = avtdta(:,:,:,2)
-
-            CALL eos( tn, sn, rhd, rhop )   ! Time-filtered in situ density 
-            CALL bn2( tn, sn, rn2 )         ! before Brunt-Vaisala frequency
+            ! Computes slopes. Caution : here tsn and avt are used as workspace
+            tsn (:,:,:,jp_tem) = tdta  (:,:,:,2)
+            tsn (:,:,:,jp_sal) = sdta  (:,:,:,2)
+            avt(:,:,:)         = avtdta(:,:,:,2)
+         
+            CALL eos( tsn, rhd, rhop )   ! Time-filtered in situ density 
+            CALL bn2( tsn, rn2 )         ! before Brunt-Vaisala frequency
             IF( ln_zps )   &
-               &   CALL zps_hde( kt, tn , sn , rhd,  &  ! Partial steps: before Horizontal DErivative
-               &                 gtu, gsu, gru,  &  ! of t, s, rd at the bottom ocean level
-               &                 gtv, gsv, grv )
+               &   CALL zps_hde( kt, jpts, tsn, gtsu, gtsv,  &  ! Partial steps: before Horizontal DErivative
+               &                           rhd, gru , grv   )    ! of t, s, rd at the bottom ocean level
                    CALL zdf_mxl( kt )              ! mixed layer depth
                    CALL ldf_slp( kt, rhd, rn2 )
@@ -261,16 +257,14 @@
 
          IF( lk_ldfslp ) THEN
-            ! Computes slopes
-            ! Caution : here tn, sn and avt are used as workspace
-            tn (:,:,:) = tdta  (:,:,:,2)
-            sn (:,:,:) = sdta  (:,:,:,2)
-            avt(:,:,:) = avtdta(:,:,:,2)
-
-            CALL eos( tn, sn, rhd, rhop )   ! Time-filtered in situ density 
-            CALL bn2( tn, sn, rn2 )         ! before Brunt-Vaisala frequency
+            ! Computes slopes. Caution : here tsn and avt are used as workspace
+            tsn (:,:,:,jp_tem) = tdta  (:,:,:,2)
+            tsn (:,:,:,jp_sal) = sdta  (:,:,:,2)
+            avt(:,:,:)         = avtdta(:,:,:,2)
+         
+            CALL eos( tsn, rhd, rhop )   ! Time-filtered in situ density 
+            CALL bn2( tsn, rn2 )         ! before Brunt-Vaisala frequency
             IF( ln_zps )   &
-               &   CALL zps_hde( kt, tn , sn , rhd,  &  ! Partial steps: before Horizontal DErivative
-               &                 gtu, gsu, gru,  &  ! of t, s, rd at the bottom ocean level
-               &                 gtv, gsv, grv )
+               &   CALL zps_hde( kt, jpts, tsn, gtsu, gtsv,  &  ! Partial steps: before Horizontal DErivative
+               &                           rhd, gru , grv   )    ! of t, s, rd at the bottom ocean level
                    CALL zdf_mxl( kt )              ! mixed layer depth
                    CALL ldf_slp( kt, rhd, rn2 )
@@ -311,5 +305,5 @@
       
       ! In any case, we need rhop
-      CALL eos( tn, sn, rhd, rhop ) 
+      CALL eos( tsn, rhd, rhop ) 
       
 #if ! defined key_degrad && defined key_traldf_c2d
@@ -320,6 +314,5 @@
       ! Compute bbl coefficients if needed
       IF( lk_trabbl ) THEN
-         tb(:,:,:) = tn(:,:,:)
-         sb(:,:,:) = sn(:,:,:)
+         tsb(:,:,:,:) = tsn(:,:,:,:)
          CALL bbl( kt, 'TRC')
       END IF
@@ -735,7 +728,7 @@
       !!----------------------------------------------------------------------
       
-      tn (:,:,:) = tdta  (:,:,:,2)
-      sn (:,:,:) = sdta  (:,:,:,2)
-      avt(:,:,:) = avtdta(:,:,:,2)
+      tsn(:,:,:,jp_tem) = tdta  (:,:,:,2)
+      tsn(:,:,:,jp_sal) = sdta  (:,:,:,2)
+      avt(:,:,:)        = avtdta(:,:,:,2)
       
       un (:,:,:) = udta  (:,:,:,2) 
@@ -796,7 +789,7 @@
       zweighm1 = 1. - pweigh
       
-      tn (:,:,:) = zweighm1 * tdta  (:,:,:,1) + pweigh * tdta  (:,:,:,2)
-      sn (:,:,:) = zweighm1 * sdta  (:,:,:,1) + pweigh * sdta  (:,:,:,2)
-      avt(:,:,:) = zweighm1 * avtdta(:,:,:,1) + pweigh * avtdta(:,:,:,2)
+      tsn(:,:,:,jp_tem) = zweighm1 * tdta  (:,:,:,1) + pweigh * tdta  (:,:,:,2)
+      tsn(:,:,:,jp_sal) = zweighm1 * sdta  (:,:,:,1) + pweigh * sdta  (:,:,:,2)
+      avt(:,:,:)        = zweighm1 * avtdta(:,:,:,1) + pweigh * avtdta(:,:,:,2)
       
       un (:,:,:) = zweighm1 * udta  (:,:,:,1) + pweigh * udta  (:,:,:,2) 
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/OFF_SRC/istate.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/OFF_SRC/istate.F90	(revision 2081)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/OFF_SRC/istate.F90	(revision 2082)
@@ -59,6 +59,5 @@
       ;   hdivn(:,:,:) = 0.e0   ;
 
-      ;   tn   (:,:,:) = 0.e0   ;   ta   (:,:,:) = 0.e0
-      ;   sn   (:,:,:) = 0.e0   ;   sa   (:,:,:) = 0.e0
+      ;   tsn  (:,:,:,:) = 0.e0 
 
       rhd  (:,:,:) = 0.e0
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/OFF_SRC/opa.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/OFF_SRC/opa.F90	(revision 2081)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/OFF_SRC/opa.F90	(revision 2082)
@@ -223,4 +223,5 @@
 
 
+      !                                     ! General initialization
                             CALL     phy_cst    ! Physical constants
                             CALL     eos_init   ! Equation of state
@@ -234,14 +235,16 @@
       IF( lk_zdfddm .AND. .NOT. lk_zdfkpp )   &
          &                  CALL zdf_ddm_init   ! double diffusive mixing
-      !                                     ! Lateral physics
 #if ! defined key_degrad
                             CALL ldf_tra_init   ! Lateral ocean tracer physics
 #endif
       IF( lk_ldfslp )       CALL ldf_slp_init   ! slope of lateral mixing
+
       !                                     ! Active tracers
                             CALL tra_qsr_init   ! penetrative solar radiation qsr
       IF( lk_trabbl     )   CALL tra_bbl_init   ! advective (and/or diffusive) bottom boundary layer scheme
 
-                            CALL     trc_ini    ! Passive tracers
+      !                                     ! Passive tracers
+                            CALL     trc_init   ! Passive tracers initialization
+      !                                     ! Dynamics
                             CALL dta_dyn_init   ! Initialization for the dynamics
                             CALL     iom_init       ! iom_put initialization
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/DIA/diaar5.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/DIA/diaar5.F90	(revision 2081)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/DIA/diaar5.F90	(revision 2082)
@@ -67,4 +67,5 @@
       REAL(wp), DIMENSION(jpi,jpj    ) ::   zarea_ssh, zbotpres
       REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zrhd, zrhop
+      REAL(wp), DIMENSION(jpi,jpj,jpk,jpts) ::   ztsn
       !!--------------------------------------------------------------------
 
@@ -82,5 +83,7 @@
 
       !                                         ! thermosteric ssh
-      CALL eos( tn, sn0, zrhd )                       ! now in situ density using initial salinity
+      ztsn(:,:,:,jp_tem) = tn (:,:,:)
+      ztsn(:,:,:,jp_sal) = sn0(:,:,:)
+      CALL eos( ztsn, zrhd )                       ! now in situ density using initial salinity
       !
       zbotpres(:,:) = 0.e0                            ! no atmospheric surface pressure, levitating sea-ice
@@ -96,5 +99,5 @@
       
       !                                         ! steric sea surface height
-      CALL eos( tn, sn, zrhd, zrhop )                 ! now in situ and potential density
+      CALL eos( tsn, zrhd, zrhop )                 ! now in situ and potential density
       zrhop(:,:,jpk) = 0.e0
       CALL iom_put( 'rhop', zrhop )
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/IOM/restart.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/IOM/restart.F90	(revision 2081)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/IOM/restart.F90	(revision 2082)
@@ -26,5 +26,7 @@
    USE zdfmxl          ! mixed layer depth
    USE trdmld_oce      ! ocean active mixed layer tracers trends variables
-
+#if defined key_zdfkpp
+   USE traswap
+#endif
    IMPLICIT NONE
    PRIVATE
@@ -205,5 +207,6 @@
          CALL iom_get( numror, jpdom_autoglo, 'rhd' , rhd  )       ! now    in situ density anomaly
       ELSE
-         CALL eos( tn, sn, rhd )   ! compute rhd
+         CALL tra_swap
+         CALL eos( tsn, rhd )   ! compute rhd
       ENDIF
 #endif
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/eosbn2.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/eosbn2.F90	(revision 2081)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/eosbn2.F90	(revision 2082)
@@ -68,5 +68,5 @@
 CONTAINS
 
-   SUBROUTINE eos_insitu( ptem, psal, prd )
+   SUBROUTINE eos_insitu( pts, prd )
       !!----------------------------------------------------------------------
       !!                   ***  ROUTINE eos_insitu  ***
@@ -98,5 +98,5 @@
       !!              prd(t,s) = rn_beta * s - rn_alpha * tn - 1.
       !!      Note that no boundary condition problem occurs in this routine
-      !!      as (ptem,psal) are defined over the whole domain.
+      !!      as pts are defined over the whole domain.
       !!
       !! ** Action  :   compute prd , the in situ density (no units)
@@ -104,7 +104,7 @@
       !! References :   Jackett and McDougall, J. Atmos. Ocean. Tech., 1994
       !!----------------------------------------------------------------------
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(in   ) ::   ptem   ! potential temperature  [Celcius]
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(in   ) ::   psal   ! salinity               [psu]
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(  out) ::   prd    ! in situ density 
+      REAL(wp), DIMENSION(jpi,jpj,jpk,jpts), INTENT(in   ) ::   pts   ! 1 : potential temperature  [Celcius]
+      !                                                               ! 2 : salinity               [psu]
+      REAL(wp), DIMENSION(jpi,jpj,jpk)     , INTENT(  out) ::   prd   ! in situ density 
       !!
       INTEGER  ::   ji, jj, jk           ! dummy loop indices
@@ -123,11 +123,11 @@
          zrau0r = 1.e0 / rau0
 !CDIR NOVERRCHK
-         zws(:,:,:) = SQRT( ABS( psal(:,:,:) ) )
+         zws(:,:,:) = SQRT( ABS( pts(:,:,:,jp_sal) ) )
          !  
          DO jk = 1, jpkm1
             DO jj = 1, jpj
                DO ji = 1, jpi
-                  zt = ptem  (ji,jj,jk)
-                  zs = psal  (ji,jj,jk)
+                  zt = pts   (ji,jj,jk,jp_tem)
+                  zs = pts   (ji,jj,jk,jp_sal)
                   zh = fsdept(ji,jj,jk)        ! depth
                   zsr= zws   (ji,jj,jk)        ! square root salinity
@@ -169,10 +169,10 @@
       CASE( 1 )                !==  Linear formulation function of temperature only  ==!
          DO jk = 1, jpkm1
-            prd(:,:,jk) = ( 0.0285 - rn_alpha * ptem(:,:,jk) ) * tmask(:,:,jk)
+            prd(:,:,jk) = ( 0.0285 - rn_alpha * pts(:,:,jk,jp_tem) ) * tmask(:,:,jk)
          END DO
          !
       CASE( 2 )                !==  Linear formulation function of temperature and salinity  ==!
          DO jk = 1, jpkm1
-            prd(:,:,jk) = ( rn_beta  * psal(:,:,jk) - rn_alpha * ptem(:,:,jk) ) * tmask(:,:,jk)
+            prd(:,:,jk) = ( rn_beta  * pts(:,:,jk,jp_sal) - rn_alpha * pts(:,:,jk,jp_tem) ) * tmask(:,:,jk)
          END DO
          !
@@ -184,5 +184,5 @@
 
 
-   SUBROUTINE eos_insitu_pot( ptem, psal, prd, prhop )
+   SUBROUTINE eos_insitu_pot( pts, prd, prhop )
       !!----------------------------------------------------------------------
       !!                  ***  ROUTINE eos_insitu_pot  ***
@@ -230,8 +230,8 @@
       !!                Brown and Campana, Mon. Weather Rev., 1978
       !!----------------------------------------------------------------------
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(in   ) ::   ptem   ! potential temperature  [Celcius]
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(in   ) ::   psal   ! salinity               [psu]
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(  out) ::   prd    ! in situ density 
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(  out) ::   prhop  ! potential density (surface referenced)
+      REAL(wp), DIMENSION(jpi,jpj,jpk,jpts), INTENT(in   ) ::   pts   ! 1 : potential temperature  [Celcius]
+      !                                                               ! 2 : salinity               [psu]
+      REAL(wp), DIMENSION(jpi,jpj,jpk     ), INTENT(  out) ::   prd    ! in situ density 
+      REAL(wp), DIMENSION(jpi,jpj,jpk     ), INTENT(  out) ::   prhop  ! potential density (surface referenced)
 
       INTEGER  ::   ji, jj, jk   ! dummy loop indices
@@ -246,11 +246,11 @@
          zrau0r = 1.e0 / rau0
 !CDIR NOVERRCHK
-         zws(:,:,:) = SQRT( ABS( psal(:,:,:) ) )
+         zws(:,:,:) = SQRT( ABS( pts(:,:,:,jp_sal) ) )
          !  
          DO jk = 1, jpkm1
             DO jj = 1, jpj
                DO ji = 1, jpi
-                  zt = ptem  (ji,jj,jk)
-                  zs = psal  (ji,jj,jk)
+                  zt = pts   (ji,jj,jk,jp_tem)
+                  zs = pts   (ji,jj,jk,jp_sal)
                   zh = fsdept(ji,jj,jk)        ! depth
                   zsr= zws   (ji,jj,jk)        ! square root salinity
@@ -295,12 +295,12 @@
       CASE( 1 )                !==  Linear formulation = F( temperature )  ==!
          DO jk = 1, jpkm1
-            prd  (:,:,jk) = ( 0.0285 - rn_alpha * ptem(:,:,jk) )        * tmask(:,:,jk)
-            prhop(:,:,jk) = ( 1.e0   +          prd (:,:,jk) ) * rau0 * tmask(:,:,jk)
+            prd  (:,:,jk) = ( 0.0285 - rn_alpha * pts(:,:,jk,jp_sal) )        * tmask(:,:,jk)
+            prhop(:,:,jk) = ( 1.e0   +            prd (:,:,jk)       ) * rau0 * tmask(:,:,jk)
          END DO
          !
       CASE( 2 )                !==  Linear formulation = F( temperature , salinity )  ==!
          DO jk = 1, jpkm1
-            prd  (:,:,jk) = ( rn_beta  * psal(:,:,jk) - rn_alpha * ptem(:,:,jk) )        * tmask(:,:,jk)
-            prhop(:,:,jk) = ( 1.e0   + prd (:,:,jk) )                         * rau0 * tmask(:,:,jk)
+            prd  (:,:,jk) = ( rn_beta  * pts(:,:,jk,jp_sal) - rn_alpha * pts(:,:,jk,jp_tem) )        * tmask(:,:,jk)
+            prhop(:,:,jk) = ( 1.e0     + prd (:,:,jk) )                                       * rau0 * tmask(:,:,jk)
          END DO
          !
@@ -312,5 +312,5 @@
 
 
-   SUBROUTINE eos_insitu_2d( ptem, psal, pdep, prd )
+   SUBROUTINE eos_insitu_2d( pts, pdep, prd )
       !!----------------------------------------------------------------------
       !!                  ***  ROUTINE eos_insitu_2d  ***
@@ -342,5 +342,5 @@
       !!              prd(t,s) = rn_beta * s - rn_alpha * tn - 1.
       !!      Note that no boundary condition problem occurs in this routine
-      !!      as (ptem,psal) are defined over the whole domain.
+      !!      as pts are defined over the whole domain.
       !!
       !! ** Action  : - prd , the in situ density (no units)
@@ -348,8 +348,8 @@
       !! References :   Jackett and McDougall, J. Atmos. Ocean. Tech., 1994
       !!----------------------------------------------------------------------
-      REAL(wp), DIMENSION(jpi,jpj), INTENT(in   ) ::   ptem   ! potential temperature  [Celcius]
-      REAL(wp), DIMENSION(jpi,jpj), INTENT(in   ) ::   psal   ! salinity               [psu]
-      REAL(wp), DIMENSION(jpi,jpj), INTENT(in   ) ::   pdep   ! depth                  [m]
-      REAL(wp), DIMENSION(jpi,jpj), INTENT(  out) ::   prd    ! in situ density 
+      REAL(wp), DIMENSION(jpi,jpj,jpts), INTENT(in   ) ::   pts   ! 1 : potential temperature  [Celcius]
+      !                                                           ! 2 : salinity               [psu]
+      REAL(wp), DIMENSION(jpi,jpj)     , INTENT(in   ) ::   pdep  ! depth                  [m]
+      REAL(wp), DIMENSION(jpi,jpj)     , INTENT(  out) ::   prd   ! in situ density 
       !!
       INTEGER  ::   ji, jj                    ! dummy loop indices
@@ -369,5 +369,5 @@
 !CDIR NOVERRCHK
             DO ji = 1, fs_jpim1   ! vector opt.
-               zws(ji,jj) = SQRT( ABS( psal(ji,jj) ) )
+               zws(ji,jj) = SQRT( ABS( pts(ji,jj,jp_sal) ) )
             END DO
          END DO
@@ -375,6 +375,6 @@
             DO ji = 1, fs_jpim1   ! vector opt.
                zmask = tmask(ji,jj,1)          ! land/sea bottom mask = surf. mask
-               zt    = ptem (ji,jj)            ! interpolated T
-               zs    = psal (ji,jj)            ! interpolated S
+               zt    = pts  (ji,jj,jp_tem)            ! interpolated T
+               zs    = pts  (ji,jj,jp_sal)            ! interpolated S
                zsr   = zws  (ji,jj)            ! square root of interpolated S
                zh    = pdep (ji,jj)            ! depth at the partial step level
@@ -416,5 +416,5 @@
          DO jj = 1, jpjm1
             DO ji = 1, fs_jpim1   ! vector opt.
-               prd(ji,jj) = ( 0.0285 - rn_alpha * ptem(ji,jj) ) * tmask(ji,jj,1)
+               prd(ji,jj) = ( 0.0285 - rn_alpha * pts(ji,jj,jp_tem) ) * tmask(ji,jj,1)
             END DO
          END DO
@@ -423,5 +423,5 @@
          DO jj = 1, jpjm1
             DO ji = 1, fs_jpim1   ! vector opt.
-               prd(ji,jj) = ( rn_beta * psal(ji,jj) - rn_alpha * ptem(ji,jj) ) * tmask(ji,jj,1) 
+               prd(ji,jj) = ( rn_beta * pts(ji,jj,jp_sal) - rn_alpha * pts(ji,jj,jp_tem) ) * tmask(ji,jj,1) 
             END DO
          END DO
@@ -434,5 +434,5 @@
 
 
-   SUBROUTINE eos_bn2( ptem, psal, pn2 )
+   SUBROUTINE eos_bn2( pts, pn2 )
       !!----------------------------------------------------------------------
       !!                  ***  ROUTINE eos_bn2  ***
@@ -464,7 +464,7 @@
       !! References :   McDougall, J. Phys. Oceanogr., 17, 1950-1964, 1987.
       !!----------------------------------------------------------------------
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(in   ) ::   ptem   ! potential temperature   [Celcius]
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(in   ) ::   psal   ! salinity                [psu]
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(  out) ::   pn2    ! Brunt-Vaisala frequency [s-1]
+      REAL(wp), DIMENSION(jpi,jpj,jpk,jpts), INTENT(in   ) ::   pts   ! 1 : potential temperature  [Celcius]
+      !                                                               ! 2 : salinity               [psu]
+      REAL(wp), DIMENSION(jpi,jpj,jpk)     , INTENT(  out) ::   pn2    ! Brunt-Vaisala frequency [s-1]
       !!
       INTEGER  ::   ji, jj, jk   ! dummy loop indices
@@ -485,6 +485,6 @@
                DO ji = 1, jpi
                   zgde3w = grav / fse3w(ji,jj,jk)
-                  zt = 0.5 * ( ptem(ji,jj,jk) + ptem(ji,jj,jk-1) )          ! potential temperature at w-point
-                  zs = 0.5 * ( psal(ji,jj,jk) + psal(ji,jj,jk-1) ) - 35.0   ! salinity anomaly (s-35) at w-point
+                  zt = 0.5 * ( pts(ji,jj,jk,jp_tem) + pts(ji,jj,jk-1,jp_tem) )          ! potential temperature at w-point
+                  zs = 0.5 * ( pts(ji,jj,jk,jp_sal) + pts(ji,jj,jk-1,jp_sal) ) - 35.0   ! salinity anomaly (s-35) at w-point
                   zh = fsdepw(ji,jj,jk)                                     ! depth in meters  at w-point
                   !
@@ -515,11 +515,11 @@
                      !
                   pn2(ji,jj,jk) = zgde3w * zbeta * tmask(ji,jj,jk)           &   ! N^2 
-                     &          * ( zalbet * ( ptem(ji,jj,jk-1) - ptem(ji,jj,jk) )   &
-                     &                     - ( psal(ji,jj,jk-1) - psal(ji,jj,jk) ) )
+                     &          * ( zalbet * ( pts(ji,jj,jk-1,jp_tem) - pts(ji,jj,jk,jp_tem) )   &
+                     &                     - ( pts(ji,jj,jk-1njp_sal) - pts(ji,jj,jk,jp_sal) ) )
 #if defined key_zdfddm
                   !                                                         !!bug **** caution a traiter zds=dk[S]= 0 !!!!
-                  zds = ( psal(ji,jj,jk-1) - psal(ji,jj,jk) )                    ! Rrau = (alpha / beta) (dk[t] / dk[s])
+                  zds = ( pts(ji,jj,jk-1,jp_sal) - pts(ji,jj,jk,jp_sal) )                    ! Rrau = (alpha / beta) (dk[t] / dk[s])
                   IF ( ABS( zds) <= 1.e-20 ) zds = 1.e-20
-                  rrau(ji,jj,jk) = zalbet * ( ptem(ji,jj,jk-1) - ptem(ji,jj,jk) ) / zds
+                  rrau(ji,jj,jk) = zalbet * ( pts(ji,jj,jk-1,jp_tem) - pts(ji,jj,jk,jp_tem) ) / zds
 #endif
                END DO
@@ -529,11 +529,11 @@
       CASE( 1 )                !==  Linear formulation = F( temperature )  ==!
          DO jk = 2, jpkm1
-            pn2(:,:,jk) = grav * rn_alpha * ( ptem(:,:,jk-1) - ptem(:,:,jk) ) / fse3w(:,:,jk) * tmask(:,:,jk)
+            pn2(:,:,jk) = grav * rn_alpha * ( pts(:,:,jk-1,jp_tem) - pts(:,:,jk,jp_tem) ) / fse3w(:,:,jk) * tmask(:,:,jk)
          END DO
          !
       CASE( 2 )                !==  Linear formulation = F( temperature , salinity )  ==!
          DO jk = 2, jpkm1
-            pn2(:,:,jk) = grav * (  rn_alpha * ( ptem(:,:,jk-1) - ptem(:,:,jk) )      &
-               &                  - rn_beta  * ( psal(:,:,jk-1) - psal(:,:,jk) )  )   &
+            pn2(:,:,jk) = grav * (  rn_alpha * ( pts(:,:,jk-1,jp_tem) - pts(:,:,jk,jp_tem) )      &
+               &                  - rn_beta  * ( pts(:,:,jk-1,jp_sal) - pts(:,:,jk,jp_sal) )  )   &
                &               / fse3w(:,:,jk) * tmask(:,:,jk)
          END DO 
@@ -542,7 +542,7 @@
             DO jj = 1, jpj
                DO ji = 1, jpi
-                  zds = ( psal(ji,jj,jk-1) - psal(ji,jj,jk) )
+                  zds = ( pts(ji,jj,jk-1,jp_sal) - pts(ji,jj,jk,jp_sal) )  
                   IF ( ABS( zds ) <= 1.e-20 ) zds = 1.e-20
-                  rrau(ji,jj,jk) = ralpbet * ( ptem(ji,jj,jk-1) - ptem(ji,jj,jk) ) / zds
+                  rrau(ji,jj,jk) = ralpbet * ( pts(ji,jj,jk-1,jp_tem) - pts(ji,jj,jk,jp_tem) ) / zds
                END DO
             END DO
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/traadv.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/traadv.F90	(revision 2081)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/traadv.F90	(revision 2082)
@@ -42,4 +42,7 @@
    INTEGER ::   nadv   ! choice of the type of advection scheme
 
+   REAL(wp), DIMENSION(jpk) ::   r2dt  ! vertical profile time-step, = 2 rdttra
+      !                                ! except at nit000 (=rdttra) if neuler=0
+
    !! * Substitutions
 #  include "domzgr_substitute.h90"
@@ -66,4 +69,10 @@
       REAL(wp), DIMENSION(jpi,jpj,jpk)   ::  zun, zvn, zwn   ! effective transport
       !!----------------------------------------------------------------------
+      !                                          ! set time step
+      IF( neuler == 0 .AND. kt == nit000 ) THEN     ! at nit000
+         r2dt(:) =  rdttra(:)                          ! = rdtra (restarting with Euler time stepping)
+      ELSEIF( kt <= nit000 + 1) THEN                ! at nit000 or nit000+1
+         r2dt(:) = 2. * rdttra(:)                      ! = 2 rdttra (leapfrog)
+      ENDIF
       !                                               !==  effective transport  ==!
       DO jk = 1, jpkm1
@@ -82,28 +91,28 @@
 
       SELECT CASE ( nadv )                            !==  compute advection trend and add it to general trend  ==!
-      CASE ( 1 )   ;    CALL tra_adv_cen2  ( kt, 'TRA', zun, zvn, zwn, tsb, tsn, tsa, jpts )   !  2nd order centered
-      CASE ( 2 )   ;    CALL tra_adv_tvd   ( kt, 'TRA', zun, zvn, zwn, tsb, tsn, tsa, jpts )   !  TVD 
-      CASE ( 3 )   ;    CALL tra_adv_muscl ( kt, 'TRA', zun, zvn, zwn, tsb,      tsa, jpts )   !  MUSCL 
-      CASE ( 4 )   ;    CALL tra_adv_muscl2( kt, 'TRA', zun, zvn, zwn, tsb, tsn, tsa, jpts )   !  MUSCL2 
-      CASE ( 5 )   ;    CALL tra_adv_ubs   ( kt, 'TRA', zun, zvn, zwn, tsb, tsn, tsa, jpts )   !  UBS 
-      CASE ( 6 )   ;    CALL tra_adv_qck   ( kt, 'TRA', zun, zvn, zwn, tsb, tsn, tsa, jpts )   !  QUICKEST 
+      CASE ( 1 )   ;    CALL tra_adv_cen2  ( kt, 'TRA',       zun, zvn, zwn, tsb, tsn, tsa, jpts )   !  2nd order centered
+      CASE ( 2 )   ;    CALL tra_adv_tvd   ( kt, 'TRA', r2dt, zun, zvn, zwn, tsb, tsn, tsa, jpts )   !  TVD 
+      CASE ( 3 )   ;    CALL tra_adv_muscl ( kt, 'TRA', r2dt, zun, zvn, zwn, tsb,      tsa, jpts )   !  MUSCL 
+      CASE ( 4 )   ;    CALL tra_adv_muscl2( kt, 'TRA', r2dt, zun, zvn, zwn, tsb, tsn, tsa, jpts )   !  MUSCL2 
+      CASE ( 5 )   ;    CALL tra_adv_ubs   ( kt, 'TRA', r2dt, zun, zvn, zwn, tsb, tsn, tsa, jpts )   !  UBS 
+      CASE ( 6 )   ;    CALL tra_adv_qck   ( kt, 'TRA', r2dt, zun, zvn, zwn, tsb, tsn, tsa, jpts )   !  QUICKEST 
       !
       CASE (-1 )                                      !==  esopa: test all possibility with control print  ==!
-         CALL tra_adv_cen2  ( kt , 'TRA', zun, zvn, zwn, tsb, tsn, tsa, jpts )          
+         CALL tra_adv_cen2  ( kt, 'TRA',       zun, zvn, zwn, tsb, tsn, tsa, jpts )          
          CALL prt_ctl( tab3d_1=tsa(:,:,:,jp_tem), clinfo1=' adv0 - Ta: ', mask1=tmask,               &
             &          tab3d_2=tsa(:,:,:,jp_sal), clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
-         CALL tra_adv_tvd   ( kt, 'TRA', zun, zvn, zwn, tsb, tsn, tsa, jpts )          
+         CALL tra_adv_tvd   ( kt, 'TRA', r2dt, zun, zvn, zwn, tsb, tsn, tsa, jpts )          
          CALL prt_ctl( tab3d_1=tsa(:,:,:,jp_tem), clinfo1=' adv1 - Ta: ', mask1=tmask,               &
             &          tab3d_2=tsa(:,:,:,jp_sal), clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
-         CALL tra_adv_muscl ( kt, 'TRA', zun, zvn, zwn, tsb,      tsa, jpts )          
+         CALL tra_adv_muscl ( kt, 'TRA', r2dt, zun, zvn, zwn, tsb,      tsa, jpts )          
          CALL prt_ctl( tab3d_1=tsa(:,:,:,jp_tem), clinfo1=' adv3 - Ta: ', mask1=tmask,               &
             &          tab3d_2=tsa(:,:,:,jp_sal), clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
-         CALL tra_adv_muscl2( kt, 'TRA', zun, zvn, zwn, tsb, tsn, tsa, jpts )          
+         CALL tra_adv_muscl2( kt, 'TRA', r2dt, zun, zvn, zwn, tsb, tsn, tsa, jpts )          
          CALL prt_ctl( tab3d_1=tsa(:,:,:,jp_tem), clinfo1=' adv4 - Ta: ', mask1=tmask,               &
             &          tab3d_2=tsa(:,:,:,jp_sal), clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
-         CALL tra_adv_ubs   ( kt, 'TRA', zun, zvn, zwn, tsb, tsn, tsa, jpts )          
+         CALL tra_adv_ubs   ( kt, 'TRA', r2dt, zun, zvn, zwn, tsb, tsn, tsa, jpts )          
          CALL prt_ctl( tab3d_1=tsa(:,:,:,jp_tem), clinfo1=' adv5 - Ta: ', mask1=tmask,               &
             &          tab3d_2=tsa(:,:,:,jp_sal), clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
-         CALL tra_adv_qck   ( kt, 'TRA', zun, zvn, zwn, tsb, tsn, tsa, jpts )          
+         CALL tra_adv_qck   ( kt, 'TRA', r2dt, zun, zvn, zwn, tsb, tsn, tsa, jpts )          
          CALL prt_ctl( tab3d_1=tsa(:,:,:,jp_tem), clinfo1=' adv6 - Ta: ', mask1=tmask,               &
             &          tab3d_2=tsa(:,:,:,jp_sal), clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
@@ -179,5 +188,4 @@
          IF( nadv ==  5 )   WRITE(numout,*) '         UBS       scheme is used'
          IF( nadv ==  6 )   WRITE(numout,*) '         QUICKEST  scheme is used'
-         IF( nadv ==  7 )   WRITE(numout,*) '         SMOLAR    scheme is used'
          IF( nadv == -1 )   WRITE(numout,*) '         esopa test: use all advection scheme'
       ENDIF
